diff --git a/isisd/isis_srv6.c b/isisd/isis_srv6.c
index be601bfd224f..7d98b65c2d0b 100644
--- a/isisd/isis_srv6.c
+++ b/isisd/isis_srv6.c
@@ -33,6 +33,29 @@
 #include "isisd/isis_zebra.h"
 
 
+/**
+ * Fill in SRv6 SID Structure Sub-Sub-TLV with information from an SRv6 SID
+ *
+ * @param sid				    SRv6 SID configuration
+ * @param structure_subsubtlv	SRv6 SID Structure Sub-Sub-TLV to be updated
+ */
+void isis_srv6_sid_structure2subsubtlv(
+	const struct isis_srv6_sid *sid,
+	struct isis_srv6_sid_structure_subsubtlv *structure_subsubtlv)
+{
+	/* Set Locator Block length */
+	structure_subsubtlv->loc_block_len = sid->structure.loc_block_len;
+
+	/* Set Locator Node length */
+	structure_subsubtlv->loc_node_len = sid->structure.loc_node_len;
+
+	/* Set Function length */
+	structure_subsubtlv->func_len = sid->structure.func_len;
+
+	/* Set Argument length */
+	structure_subsubtlv->arg_len = sid->structure.arg_len;
+}
+
 /**
  * Fill in SRv6 End SID Sub-TLV with information from an SRv6 End SID.
  *
diff --git a/isisd/isis_srv6.h b/isisd/isis_srv6.h
index 36ce7664a4c9..ea15dcbc2b7e 100644
--- a/isisd/isis_srv6.h
+++ b/isisd/isis_srv6.h
@@ -119,5 +119,8 @@ void isis_srv6_locator2tlv(const struct isis_srv6_locator *loc,
 			   struct isis_srv6_locator_tlv *loc_tlv);
 void isis_srv6_end_sid2subtlv(const struct isis_srv6_sid *sid,
 			      struct isis_srv6_end_sid_subtlv *sid_subtlv);
+void isis_srv6_sid_structure2subsubtlv(
+	const struct isis_srv6_sid *sid,
+	struct isis_srv6_sid_structure_subsubtlv *structure_subsubtlv);
 
 #endif /* _FRR_ISIS_SRV6_H */
